<template>
    <div>
        <section class="">
            <div class="container">
                <div class="level is-mobile">
                    <!-- Left side -->
                    <div class="level-left">
                    </div>
                    <!-- Right side -->
                    <div class="level-right">
                        <p class="level-item"><nuxt-link to="/topics" class="button is-danger is-outlined">Cancel</nuxt-link></p>
                    </div>
                    
                </div>
                <div class="title-wrapper has-text-centered">
                    <h2 class="title is-2 is-spaced">Start a topic</h2>
                    <h3 class="subtitle is-5 is-muted">We'd love to hear from You</h3>
                    <div class="divider is-centered"></div>
                </div>
                <div class="content-wrapper">
                    
                    <div class="columns">
                        <div class="content column is-4 is-offset-2">
                            <ul>
                                <li>Chats will not be available on public once someone has started a chat</li> 
                                <li>You can repost the chat after it's ended</li> 
                                <li>Chats expire 7 days after it starts</li> 
                                <li>You can choose to end the chat anytime</li>
                            </ul>
                                
                        </div> 
                        <div class="column is-4" style="margin: 10px;">
                            
                                <div class="columns is-multiline">
                                    <div class="column is-12">
                                        <input placeholder="Enter your topic" class="input is-medium" v-model="topic">
                                    </div> 
                                    <div class="column is-12">
                                        <textarea rows="10" placeholder="Tell us more about it ..." class="textarea" v-model="msg"></textarea>
                                    </div> 
                                    <div class="column is-12">
                                        <p>Will be posted as <strong>{{name}} </strong><nuxt-link to="profile">view profile</nuxt-link> </p> 
                                    </div> 
                                    <div class="form-footer has-text-centered mt-10">
                                        <button @click="addTopic" class="button cta is-large primary-btn raised is-clear" 
                                        :class="{ 'is-loading': loading }">Start Topic</button>
                                    </div>
                                </div>
                            
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </div>
</template>

<script>
import { DB } from '@/plugins/firebase.js'

export default {
  data: function () {
    return {
        topic: 'topic',
        msg: 'i have a message',
        loading: false,
        uid: this.$store.getters.isAuthenticated,
        name: this.$store.getters.name
    }
  },
  methods: {
    addTopic: function () {
        var self = this
        var uid = this.uid
        this.loading = true
        
      // Get a key for a new Post.
      var newPostKey = DB.ref().child('topics').push().key
      
      //timestamp
      //var ts = new Date.now()
        var ts = new Date().getTime()
      
        var postData = {
            topic: this.topic,
            msg: this.msg,
            key: newPostKey,
            reposts: '0',
            timeposted: ts,
            creator: {
                uid: this.uid,
                name: this.name
            },
            state: '1',
            chat: {
                [newPostKey]: {
                    uid: this.uid,
                    msg: this.msg
                }
            }
        }
        console.log(postData)

      var updates = {}
      updates['/topics/' + newPostKey] = postData
      //updates['/users/' + uid + '/topics/' + newPostKey] = postData
      
      DB.ref().update(updates)
      .then(function() {
          self.$izitoast.success({
                title: 'Yay',
                message: "Topic posted!"
          })
          self.loading = false
          self.$router.push('/topics')
      })
      .catch(function(error) {
          self.$izitoast.error({
                title: 'Uhh',
                message: "something failed..."
          })
      })
    },
  },
  middleware: 'auth'
}
</script>
